#ifndef WINDOW
#define WINDOW
#pragma once

#include "pattern.h"

class Window {
public:
  Window() {}
  Window(int _rows, int _cols): rows(_rows), cols(_cols) {
    data.resize(rows);
    for (int i = 0; i < rows; ++i) {
      data[i].resize(cols, -1);
    }
  }

  int area() const {
    return this->rows * this->cols;
  }

  bool operator<(const Window& other) const {
    return this->area() > other.area();
  }

  void placePattern(const Pattern& p, int patternInd, int r, int c) {
    for (int i = 0; i < p.rows; ++i) {
      for (int j = 0; j < p.cols; ++j) {
        if (p.data[i][j]) {
          data[r + i][c + j] = patternInd;
        }
      }
    }
    // print();
    // fprintf(stderr, "Placing pattern %d in window %d, (%d, %d)\n", p.ind, ind, r, c);
  }

  void print() {
    for (int i = 0; i < rows; ++i) {
      for (int j = 0; j < cols; ++j) {
        fprintf(stderr, "%d", data[i][j]);
      }
      fprintf(stderr, "\n");
    }
  }

  void unmountPattern(const Pattern& p, int r, int c) {
    //fprintf(stderr, "\n~~HERE!\n");
    for (int i = 0; i < p.rows; ++i) {
      for (int j = 0; j < p.cols; ++j) {
        if (p.data[i][j]) {
          data[r + i][c + j] = -1;
        }
      }
    }
  }

  int rows;
  int cols;
  int ind;
  std::vector<std::vector<int> > data;
};

#endif
